import "./style.css";
import { callEntry as y, useCanvas as A, useMaterial as B, useLayout as P, getMergeMeta as K, useHistory as L, useMessage as z, useCompile as W } from "@opentiny/tiny-engine-meta-register";
import { defineComponent as de, computed as J, ref as re, reactive as oe, resolveComponent as Z, createElementBlock as Q, openBlock as q, unref as T, Fragment as se, renderList as ue, withDirectives as ge, normalizeClass as ee, createElementVNode as te, normalizeStyle as pe, createCommentVNode as ne, createBlock as ie, withModifiers as me, renderSlot as De, mergeProps as fe, vShow as he, provide as ve, onActivated as ye, onDeactivated as be, watch as xe, nextTick as Ce, onMounted as Se, onBeforeUnmount as _e, withCtx as le, createVNode as ae, toDisplayString as Ne } from "vue";
import { PluginPanel as U } from "@opentiny/tiny-engine-common";
import { constants as G } from "@opentiny/tiny-engine-utils";
import { extend as F } from "@opentiny/vue-renderless/common/object";
const $ = {
  id: "engine.plugins.outlinetree",
  title: "大纲树",
  type: "plugins",
  icon: "plugin-icon-tree",
  // icon: 'plugin-icon-var',
  widthResizable: !0,
  align: "leftTop"
}, ke = ["draggable", "onClick", "onMouseenter", "onDragstart", "onDragover", "onDragenter"], we = {
  key: 0,
  class: "expand-icon"
}, Me = /* @__PURE__ */ de({
  __name: "DraggableTree",
  props: {
    data: {
      type: Array,
      default: () => []
    },
    active: {
      type: String
    },
    actives: {
      type: Array,
      default: () => []
    },
    idKey: {
      type: String,
      default: "id"
    },
    labelKey: {
      type: String,
      default: "label"
    },
    childrenKey: {
      type: String,
      default: "children"
    },
    draggable: {
      type: Boolean,
      default: !1
    },
    disallowDrop: {
      type: Function,
      default: () => !1
    }
  },
  emits: ["click", "mouseenter", "drop"],
  setup(E, {
    emit: I
  }) {
    const t = E, o = J(() => t.actives.length === 0 && t.active ? [t.active] : t.actives), r = y((e) => {
      const {
        idKey: a,
        labelKey: g,
        childrenKey: w
      } = t, H = e[a], Y = e[g], V = e[w], R = {
        id: H,
        label: Y,
        rawData: e
      };
      return Array.isArray(V) && (R.children = V.map((X) => r(X))), R;
    }, {
      metaData: {
        id: "engine.plugins.outlinetree.normalizeDataItem"
      },
      ctx: () => ({
        props: t,
        activesComputed: o,
        normalizeDataItem: r,
        normalizeData: D,
        normalizedData: s,
        useCollapseMap: p,
        collapseMap: b,
        setCollapse: l,
        switchCollapse: k,
        flattenNode: d,
        flattenNodes: u,
        rows: f,
        emit: m,
        handleClickRow: x,
        handleMouseEnterRow: C,
        useDraggingState: S,
        draggingState: i,
        resetDraggingState: M,
        handleDragStart: _,
        getPositionData: N,
        handleDragOver: h,
        handleDrop: c,
        handleDragEnd: v,
        handleDragLeaveContainer: n
      })
    }), D = y((e) => Array.isArray(e) ? e.map((a) => r(a)) : [], {
      metaData: {
        id: "engine.plugins.outlinetree.normalizeData"
      },
      ctx: () => ({
        props: t,
        activesComputed: o,
        normalizeDataItem: r,
        normalizeData: D,
        normalizedData: s,
        useCollapseMap: p,
        collapseMap: b,
        setCollapse: l,
        switchCollapse: k,
        flattenNode: d,
        flattenNodes: u,
        rows: f,
        emit: m,
        handleClickRow: x,
        handleMouseEnterRow: C,
        useDraggingState: S,
        draggingState: i,
        resetDraggingState: M,
        handleDragStart: _,
        getPositionData: N,
        handleDragOver: h,
        handleDrop: c,
        handleDragEnd: v,
        handleDragLeaveContainer: n
      })
    }), s = J(() => D(t.data)), p = y(() => {
      const e = re({}), a = y((w, H) => {
        e.value[w] = H;
      }, {
        metaData: {
          id: "engine.plugins.outlinetree.setCollapse"
        },
        ctx: () => ({
          collapseMap: e,
          setCollapse: a,
          switchCollapse: g,
          props: t,
          activesComputed: o,
          normalizeDataItem: r,
          normalizeData: D,
          normalizedData: s,
          useCollapseMap: p,
          flattenNode: d,
          flattenNodes: u,
          rows: f,
          emit: m,
          handleClickRow: x,
          handleMouseEnterRow: C,
          useDraggingState: S,
          draggingState: i,
          resetDraggingState: M,
          handleDragStart: _,
          getPositionData: N,
          handleDragOver: h,
          handleDrop: c,
          handleDragEnd: v,
          handleDragLeaveContainer: n
        })
      }), g = y((w) => {
        e.value[w] = !e.value[w];
      }, {
        metaData: {
          id: "engine.plugins.outlinetree.switchCollapse"
        },
        ctx: () => ({
          collapseMap: e,
          setCollapse: a,
          switchCollapse: g,
          props: t,
          activesComputed: o,
          normalizeDataItem: r,
          normalizeData: D,
          normalizedData: s,
          useCollapseMap: p,
          flattenNode: d,
          flattenNodes: u,
          rows: f,
          emit: m,
          handleClickRow: x,
          handleMouseEnterRow: C,
          useDraggingState: S,
          draggingState: i,
          resetDraggingState: M,
          handleDragStart: _,
          getPositionData: N,
          handleDragOver: h,
          handleDrop: c,
          handleDragEnd: v,
          handleDragLeaveContainer: n
        })
      });
      return {
        collapseMap: e,
        setCollapse: a,
        switchCollapse: g
      };
    }, {
      metaData: {
        id: "engine.plugins.outlinetree.useCollapseMap"
      },
      ctx: () => ({
        props: t,
        activesComputed: o,
        normalizeDataItem: r,
        normalizeData: D,
        normalizedData: s,
        useCollapseMap: p,
        flattenNode: d,
        flattenNodes: u,
        rows: f,
        emit: m,
        handleClickRow: x,
        handleMouseEnterRow: C,
        useDraggingState: S,
        draggingState: i,
        resetDraggingState: M,
        handleDragStart: _,
        getPositionData: N,
        handleDragOver: h,
        handleDrop: c,
        handleDragEnd: v,
        handleDragLeaveContainer: n
      })
    }), {
      collapseMap: b,
      setCollapse: l,
      switchCollapse: k
    } = p(), d = y((e, a, g = 0, w = !1) => {
      const {
        children: H,
        ...Y
      } = e, V = (H || []).map((X) => d(X, e.id, g + 1, w || b.value[e.id])).flat(), R = {
        ...Y,
        parentId: a,
        level: g,
        hasChildren: (H == null ? void 0 : H.length) > 0,
        collapsed: w
      };
      return V.forEach((X) => {
        X.parent || (X.parent = R);
      }), [R].concat(V);
    }, {
      metaData: {
        id: "engine.plugins.outlinetree.flattenNode"
      },
      ctx: () => ({
        props: t,
        activesComputed: o,
        normalizeDataItem: r,
        normalizeData: D,
        normalizedData: s,
        useCollapseMap: p,
        collapseMap: b,
        setCollapse: l,
        switchCollapse: k,
        flattenNode: d,
        flattenNodes: u,
        rows: f,
        emit: m,
        handleClickRow: x,
        handleMouseEnterRow: C,
        useDraggingState: S,
        draggingState: i,
        resetDraggingState: M,
        handleDragStart: _,
        getPositionData: N,
        handleDragOver: h,
        handleDrop: c,
        handleDragEnd: v,
        handleDragLeaveContainer: n
      })
    }), u = y((e) => d({
      children: e
    }, null, -1).slice(1), {
      metaData: {
        id: "engine.plugins.outlinetree.flattenNodes"
      },
      ctx: () => ({
        props: t,
        activesComputed: o,
        normalizeDataItem: r,
        normalizeData: D,
        normalizedData: s,
        useCollapseMap: p,
        collapseMap: b,
        setCollapse: l,
        switchCollapse: k,
        flattenNode: d,
        flattenNodes: u,
        rows: f,
        emit: m,
        handleClickRow: x,
        handleMouseEnterRow: C,
        useDraggingState: S,
        draggingState: i,
        resetDraggingState: M,
        handleDragStart: _,
        getPositionData: N,
        handleDragOver: h,
        handleDrop: c,
        handleDragEnd: v,
        handleDragLeaveContainer: n
      })
    }), f = J(() => u(s.value)), m = I, x = y((e, a) => {
      m("click", e, a);
    }, {
      metaData: {
        id: "engine.plugins.outlinetree.handleClickRow"
      },
      ctx: () => ({
        props: t,
        activesComputed: o,
        normalizeDataItem: r,
        normalizeData: D,
        normalizedData: s,
        useCollapseMap: p,
        collapseMap: b,
        setCollapse: l,
        switchCollapse: k,
        flattenNode: d,
        flattenNodes: u,
        rows: f,
        emit: m,
        handleClickRow: x,
        handleMouseEnterRow: C,
        useDraggingState: S,
        draggingState: i,
        resetDraggingState: M,
        handleDragStart: _,
        getPositionData: N,
        handleDragOver: h,
        handleDrop: c,
        handleDragEnd: v,
        handleDragLeaveContainer: n
      })
    }), C = y((e) => {
      m("mouseenter", e);
    }, {
      metaData: {
        id: "engine.plugins.outlinetree.handleMouseEnterRow"
      },
      ctx: () => ({
        props: t,
        activesComputed: o,
        normalizeDataItem: r,
        normalizeData: D,
        normalizedData: s,
        useCollapseMap: p,
        collapseMap: b,
        setCollapse: l,
        switchCollapse: k,
        flattenNode: d,
        flattenNodes: u,
        rows: f,
        emit: m,
        handleClickRow: x,
        handleMouseEnterRow: C,
        useDraggingState: S,
        draggingState: i,
        resetDraggingState: M,
        handleDragStart: _,
        getPositionData: N,
        handleDragOver: h,
        handleDrop: c,
        handleDragEnd: v,
        handleDragLeaveContainer: n
      })
    }), S = y(() => {
      const e = {
        dragged: null,
        hovering: null,
        position: "",
        borderClass: "",
        forbidInsert: !1
      }, a = oe({
        ...e
      }), g = y(() => {
        Object.assign(a, e);
      }, {
        metaData: {
          id: "engine.plugins.outlinetree.resetDraggingState"
        },
        ctx: () => ({
          initialState: e,
          draggingState: a,
          resetDraggingState: g,
          props: t,
          activesComputed: o,
          normalizeDataItem: r,
          normalizeData: D,
          normalizedData: s,
          useCollapseMap: p,
          collapseMap: b,
          setCollapse: l,
          switchCollapse: k,
          flattenNode: d,
          flattenNodes: u,
          rows: f,
          emit: m,
          handleClickRow: x,
          handleMouseEnterRow: C,
          useDraggingState: S,
          handleDragStart: _,
          getPositionData: N,
          handleDragOver: h,
          handleDrop: c,
          handleDragEnd: v,
          handleDragLeaveContainer: n
        })
      });
      return {
        draggingState: a,
        resetDraggingState: g
      };
    }, {
      metaData: {
        id: "engine.plugins.outlinetree.useDraggingState"
      },
      ctx: () => ({
        props: t,
        activesComputed: o,
        normalizeDataItem: r,
        normalizeData: D,
        normalizedData: s,
        useCollapseMap: p,
        collapseMap: b,
        setCollapse: l,
        switchCollapse: k,
        flattenNode: d,
        flattenNodes: u,
        rows: f,
        emit: m,
        handleClickRow: x,
        handleMouseEnterRow: C,
        useDraggingState: S,
        handleDragStart: _,
        getPositionData: N,
        handleDragOver: h,
        handleDrop: c,
        handleDragEnd: v,
        handleDragLeaveContainer: n
      })
    }), {
      draggingState: i,
      resetDraggingState: M
    } = S(), _ = y((e, a) => {
      t.draggable && (e.dataTransfer.setDragImage(new Image(), 0, 0), i.dragged = a, a.hasChildren && l(a.id, !0));
    }, {
      metaData: {
        id: "engine.plugins.outlinetree.handleDragStart"
      },
      ctx: () => ({
        props: t,
        activesComputed: o,
        normalizeDataItem: r,
        normalizeData: D,
        normalizedData: s,
        useCollapseMap: p,
        collapseMap: b,
        setCollapse: l,
        switchCollapse: k,
        flattenNode: d,
        flattenNodes: u,
        rows: f,
        emit: m,
        handleClickRow: x,
        handleMouseEnterRow: C,
        useDraggingState: S,
        draggingState: i,
        resetDraggingState: M,
        handleDragStart: _,
        getPositionData: N,
        handleDragOver: h,
        handleDrop: c,
        handleDragEnd: v,
        handleDragLeaveContainer: n
      })
    }), N = y((e) => {
      const a = e.currentTarget.getBoundingClientRect(), g = e.clientY - a.top, w = 8;
      return g <= w ? {
        position: "top",
        borderClass: "border-top"
      } : g >= a.height - w ? {
        position: "bottom",
        borderClass: "border-bottom"
      } : {
        position: "center",
        borderClass: "border-all"
      };
    }, {
      metaData: {
        id: "engine.plugins.outlinetree.getPositionData"
      },
      ctx: () => ({
        props: t,
        activesComputed: o,
        normalizeDataItem: r,
        normalizeData: D,
        normalizedData: s,
        useCollapseMap: p,
        collapseMap: b,
        setCollapse: l,
        switchCollapse: k,
        flattenNode: d,
        flattenNodes: u,
        rows: f,
        emit: m,
        handleClickRow: x,
        handleMouseEnterRow: C,
        useDraggingState: S,
        draggingState: i,
        resetDraggingState: M,
        handleDragStart: _,
        getPositionData: N,
        handleDragOver: h,
        handleDrop: c,
        handleDragEnd: v,
        handleDragLeaveContainer: n
      })
    }), h = y((e, a) => {
      if (!t.draggable)
        return;
      const g = N(e);
      if (a.id === f.value[0].id && g.position !== "center") {
        e.preventDefault();
        return;
      }
      if (t.disallowDrop({
        dragged: i.dragged,
        target: a,
        position: g.position
      })) {
        Object.assign(i, {
          ...g,
          hovering: a,
          forbidInsert: !0
        });
        return;
      }
      e.preventDefault(), Object.assign(i, {
        ...g,
        hovering: a,
        forbidInsert: !1
      });
    }, {
      metaData: {
        id: "engine.plugins.outlinetree.handleDragOver"
      },
      ctx: () => ({
        props: t,
        activesComputed: o,
        normalizeDataItem: r,
        normalizeData: D,
        normalizedData: s,
        useCollapseMap: p,
        collapseMap: b,
        setCollapse: l,
        switchCollapse: k,
        flattenNode: d,
        flattenNodes: u,
        rows: f,
        emit: m,
        handleClickRow: x,
        handleMouseEnterRow: C,
        useDraggingState: S,
        draggingState: i,
        resetDraggingState: M,
        handleDragStart: _,
        getPositionData: N,
        handleDragOver: h,
        handleDrop: c,
        handleDragEnd: v,
        handleDragLeaveContainer: n
      })
    }), c = y(() => {
      if (!t.draggable || i.forbidInsert)
        return;
      const {
        dragged: e,
        hovering: a,
        position: g
      } = i;
      m("drop", {
        dragged: e,
        target: a,
        position: g
      });
    }, {
      metaData: {
        id: "engine.plugins.outlinetree.handleDrop"
      },
      ctx: () => ({
        props: t,
        activesComputed: o,
        normalizeDataItem: r,
        normalizeData: D,
        normalizedData: s,
        useCollapseMap: p,
        collapseMap: b,
        setCollapse: l,
        switchCollapse: k,
        flattenNode: d,
        flattenNodes: u,
        rows: f,
        emit: m,
        handleClickRow: x,
        handleMouseEnterRow: C,
        useDraggingState: S,
        draggingState: i,
        resetDraggingState: M,
        handleDragStart: _,
        getPositionData: N,
        handleDragOver: h,
        handleDrop: c,
        handleDragEnd: v,
        handleDragLeaveContainer: n
      })
    }), v = y(() => {
      M();
    }, {
      metaData: {
        id: "engine.plugins.outlinetree.handleDragEnd"
      },
      ctx: () => ({
        props: t,
        activesComputed: o,
        normalizeDataItem: r,
        normalizeData: D,
        normalizedData: s,
        useCollapseMap: p,
        collapseMap: b,
        setCollapse: l,
        switchCollapse: k,
        flattenNode: d,
        flattenNodes: u,
        rows: f,
        emit: m,
        handleClickRow: x,
        handleMouseEnterRow: C,
        useDraggingState: S,
        draggingState: i,
        resetDraggingState: M,
        handleDragStart: _,
        getPositionData: N,
        handleDragOver: h,
        handleDrop: c,
        handleDragEnd: v,
        handleDragLeaveContainer: n
      })
    }), n = y((e) => {
      if (!t.draggable)
        return;
      const a = e.currentTarget.getBoundingClientRect(), g = 4;
      (e.clientX <= a.left + g || e.clientX >= a.right - g || e.clientY <= a.top + g || e.clientY >= a.bottom - g) && Object.assign(i, {
        hovering: null
      });
    }, {
      metaData: {
        id: "engine.plugins.outlinetree.handleDragLeaveContainer"
      },
      ctx: () => ({
        props: t,
        activesComputed: o,
        normalizeDataItem: r,
        normalizeData: D,
        normalizedData: s,
        useCollapseMap: p,
        collapseMap: b,
        setCollapse: l,
        switchCollapse: k,
        flattenNode: d,
        flattenNodes: u,
        rows: f,
        emit: m,
        handleClickRow: x,
        handleMouseEnterRow: C,
        useDraggingState: S,
        draggingState: i,
        resetDraggingState: M,
        handleDragStart: _,
        getPositionData: N,
        handleDragOver: h,
        handleDrop: c,
        handleDragEnd: v,
        handleDragLeaveContainer: n
      })
    });
    return (e, a) => {
      const g = Z("svg-icon");
      return q(), Q("div", {
        class: "draggable-tree",
        onDragleave: a[2] || (a[2] = //@ts-ignore
        (...w) => T(n) && T(n)(...w))
      }, [(q(!0), Q(se, null, ue(f.value, (w) => {
        var H, Y, V;
        return ge((q(), Q("div", {
          key: w.id,
          class: ee(["tree-row", "flex-center", {
            active: o.value.includes(w.id),
            dragging: ((H = T(i).hovering) == null ? void 0 : H.id) === w.id,
            "border-all": ((Y = T(i).hovering) == null ? void 0 : Y.id) === w.id && T(i).position === "center",
            forbid: T(i).forbidInsert
          }]),
          draggable: E.draggable ? "true" : void 0,
          onClick: (R) => T(x)(R, w),
          onMouseenter: (R) => T(C)(w),
          onDragstart: (R) => T(_)(R, w),
          onDragover: (R) => T(h)(R, w),
          onDragenter: (R) => T(h)(R, w),
          onDrop: a[0] || (a[0] = //@ts-ignore
          (...R) => T(c) && T(c)(...R)),
          onDragend: a[1] || (a[1] = //@ts-ignore
          (...R) => T(v) && T(v)(...R))
        }, [te("div", {
          class: "content flex-center",
          style: pe({
            paddingLeft: `${12 * w.level}px`
          })
        }, [w.hasChildren ? ne("", !0) : (q(), Q("span", we)), w.hasChildren ? (q(), ie(g, {
          key: 1,
          name: "dropdown",
          class: ee(["expand-icon", {
            rotate: T(b)[w.id]
          }]),
          onClick: me((R) => T(k)(w.id), ["stop"])
        }, null, 8, ["class", "onClick"])) : ne("", !0), te("div", {
          class: ee(["slot-content", "flex-center", {
            [T(i).borderClass]: ((V = T(i).hovering) == null ? void 0 : V.id) === w.id && T(i).position !== "center",
            forbid: T(i).forbidInsert
          }])
        }, [De(e.$slots, "content", fe({
          ref_for: !0
        }, w), void 0, !0)], 2)], 4)], 42, ke)), [[he, !w.collapsed]]);
      }), 128))], 32);
    };
  }
}), ce = (E, I) => {
  const t = E.__vccOpts || E;
  for (const [o, r] of I)
    t[o] = r;
  return t;
}, j = /* @__PURE__ */ ce(Me, [["__scopeId", "data-v-e830c501"]]), {
  PAGE_STATUS: O
} = G, Ee = {
  components: {
    PluginPanel: U,
    DraggableTree: j
  },
  props: {
    fixedPanels: {
      type: Array
    }
  },
  emits: ["close", "fix-panel"],
  setup(E, {
    emit: I
  }) {
    const {
      pageState: t
    } = A(), {
      getMaterial: o
    } = B(), {
      PLUGIN_NAME: r
    } = P(), D = J(() => {
      var n;
      return (n = E.fixedPanels) == null ? void 0 : n.includes(r.OutlineTree);
    }), {
      useMultiSelect: s,
      registerHotkeyEvent: p,
      removeHotkeyEvent: b
    } = K("engine.canvas.container").api, l = J(() => s().multiSelectedStates.value.map((n) => n.id)), k = oe({
      emitEvent: I
    });
    ve("panelState", k);
    const d = y((n) => {
      const e = y((a) => (a.forEach((g) => {
        g.show = t.nodesStatus[g.id] !== !1, g.showEye = !g.show;
        const w = g.children;
        Array.isArray(w) && e(g.children);
      }), a), {
        metaData: {
          id: `${$.id}.translateChild`
        },
        ctx: () => ({
          translateChild: e,
          props: E,
          emit: I,
          pageState: t,
          getMaterial: o,
          PLUGIN_NAME: r,
          panelFixed: D,
          useMultiSelect: s,
          registerHotkeyEvent: p,
          removeHotkeyEvent: b,
          selectedIds: l,
          panelState: k,
          filterSchema: d,
          state: u,
          subscribe: f,
          unsubscribe: m,
          eyeOpen: x,
          showNode: C,
          delNode: S,
          handleMouseEnterRow: i,
          disallowDrop: M,
          handleDrop: _,
          handleClickRow: N,
          getIconName: h,
          panelRef: c,
          eventFilter: v,
          PluginPanel: U,
          constants: G,
          useCanvas: A,
          useMaterial: B,
          useLayout: P,
          useMessage: z,
          useHistory: L,
          getMergeMeta: K,
          extend: F,
          DraggableTree: j,
          PAGE_STATUS: O
        })
      });
      return [{
        ...e([F(!0, {}, n)])[0],
        componentName: "body",
        id: "body"
      }];
    }, {
      metaData: {
        id: `${$.id}.filterSchema`
      },
      ctx: () => ({
        props: E,
        emit: I,
        pageState: t,
        getMaterial: o,
        PLUGIN_NAME: r,
        panelFixed: D,
        useMultiSelect: s,
        registerHotkeyEvent: p,
        removeHotkeyEvent: b,
        selectedIds: l,
        panelState: k,
        filterSchema: d,
        state: u,
        subscribe: f,
        unsubscribe: m,
        eyeOpen: x,
        showNode: C,
        delNode: S,
        handleMouseEnterRow: i,
        disallowDrop: M,
        handleDrop: _,
        handleClickRow: N,
        getIconName: h,
        panelRef: c,
        eventFilter: v,
        PluginPanel: U,
        constants: G,
        useCanvas: A,
        useMaterial: B,
        useLayout: P,
        useMessage: z,
        useHistory: L,
        getMergeMeta: K,
        extend: F,
        DraggableTree: j,
        PAGE_STATUS: O
      })
    }), u = oe({
      pageSchema: [],
      isLock: J(() => ![O.Occupy, O.Guest].includes(P().layoutState.pageStatus.state))
    }), {
      subscribe: f,
      unsubscribe: m
    } = z();
    ye(y(y(() => {
      u.pageSchema = d(t.pageSchema), f({
        topic: "schemaChange",
        subscriber: "node-tree",
        callback: ({
          operation: n
        }) => {
          (n == null ? void 0 : n.type) !== "changeProps" && (u.pageSchema = d(t.pageSchema));
        }
      });
    }, {
      metaData: {
        id: `${$.id}.onActivated[0]`
      },
      ctx: () => ({
        props: E,
        emit: I,
        pageState: t,
        getMaterial: o,
        PLUGIN_NAME: r,
        panelFixed: D,
        useMultiSelect: s,
        registerHotkeyEvent: p,
        removeHotkeyEvent: b,
        selectedIds: l,
        panelState: k,
        filterSchema: d,
        state: u,
        subscribe: f,
        unsubscribe: m,
        eyeOpen: x,
        showNode: C,
        delNode: S,
        handleMouseEnterRow: i,
        disallowDrop: M,
        handleDrop: _,
        handleClickRow: N,
        getIconName: h,
        panelRef: c,
        eventFilter: v,
        PluginPanel: U,
        constants: G,
        useCanvas: A,
        useMaterial: B,
        useLayout: P,
        useMessage: z,
        useHistory: L,
        getMergeMeta: K,
        extend: F,
        DraggableTree: j,
        PAGE_STATUS: O
      })
    }), {
      metaData: {
        id: `${$.id}.onActivated[0]`
      },
      ctx: () => ({
        props: E,
        emit: I,
        pageState: t,
        getMaterial: o,
        PLUGIN_NAME: r,
        panelFixed: D,
        useMultiSelect: s,
        registerHotkeyEvent: p,
        removeHotkeyEvent: b,
        selectedIds: l,
        panelState: k,
        filterSchema: d,
        state: u,
        subscribe: f,
        unsubscribe: m,
        eyeOpen: x,
        showNode: C,
        delNode: S,
        handleMouseEnterRow: i,
        disallowDrop: M,
        handleDrop: _,
        handleClickRow: N,
        getIconName: h,
        panelRef: c,
        eventFilter: v,
        _callEntry: y,
        _useCompile: W,
        _metaData: $,
        PluginPanel: U,
        constants: G,
        useCanvas: A,
        useMaterial: B,
        useLayout: P,
        useMessage: z,
        useHistory: L,
        getMergeMeta: K,
        extend: F,
        DraggableTree: j,
        PAGE_STATUS: O
      })
    })), be(y(y(() => {
      m({
        topic: "schemaChange",
        subscriber: "node-tree"
      });
    }, {
      metaData: {
        id: `${$.id}.onDeactivated[0]`
      },
      ctx: () => ({
        props: E,
        emit: I,
        pageState: t,
        getMaterial: o,
        PLUGIN_NAME: r,
        panelFixed: D,
        useMultiSelect: s,
        registerHotkeyEvent: p,
        removeHotkeyEvent: b,
        selectedIds: l,
        panelState: k,
        filterSchema: d,
        state: u,
        subscribe: f,
        unsubscribe: m,
        eyeOpen: x,
        showNode: C,
        delNode: S,
        handleMouseEnterRow: i,
        disallowDrop: M,
        handleDrop: _,
        handleClickRow: N,
        getIconName: h,
        panelRef: c,
        eventFilter: v,
        PluginPanel: U,
        constants: G,
        useCanvas: A,
        useMaterial: B,
        useLayout: P,
        useMessage: z,
        useHistory: L,
        getMergeMeta: K,
        extend: F,
        DraggableTree: j,
        PAGE_STATUS: O
      })
    }), {
      metaData: {
        id: `${$.id}.onDeactivated[0]`
      },
      ctx: () => ({
        props: E,
        emit: I,
        pageState: t,
        getMaterial: o,
        PLUGIN_NAME: r,
        panelFixed: D,
        useMultiSelect: s,
        registerHotkeyEvent: p,
        removeHotkeyEvent: b,
        selectedIds: l,
        panelState: k,
        filterSchema: d,
        state: u,
        subscribe: f,
        unsubscribe: m,
        eyeOpen: x,
        showNode: C,
        delNode: S,
        handleMouseEnterRow: i,
        disallowDrop: M,
        handleDrop: _,
        handleClickRow: N,
        getIconName: h,
        panelRef: c,
        eventFilter: v,
        _callEntry: y,
        _useCompile: W,
        _metaData: $,
        PluginPanel: U,
        constants: G,
        useCanvas: A,
        useMaterial: B,
        useLayout: P,
        useMessage: z,
        useHistory: L,
        getMergeMeta: K,
        extend: F,
        DraggableTree: j,
        PAGE_STATUS: O
      })
    })), xe(() => t.currentSchema, () => {
      const {
        getSchema: n
      } = A();
      u.pageSchema = d(n());
    });
    const x = y((n) => t.nodesStatus[n] !== !1, {
      metaData: {
        id: `${$.id}.eyeOpen`
      },
      ctx: () => ({
        props: E,
        emit: I,
        pageState: t,
        getMaterial: o,
        PLUGIN_NAME: r,
        panelFixed: D,
        useMultiSelect: s,
        registerHotkeyEvent: p,
        removeHotkeyEvent: b,
        selectedIds: l,
        panelState: k,
        filterSchema: d,
        state: u,
        subscribe: f,
        unsubscribe: m,
        eyeOpen: x,
        showNode: C,
        delNode: S,
        handleMouseEnterRow: i,
        disallowDrop: M,
        handleDrop: _,
        handleClickRow: N,
        getIconName: h,
        panelRef: c,
        eventFilter: v,
        PluginPanel: U,
        constants: G,
        useCanvas: A,
        useMaterial: B,
        useLayout: P,
        useMessage: z,
        useHistory: L,
        getMergeMeta: K,
        extend: F,
        DraggableTree: j,
        PAGE_STATUS: O
      })
    }), C = y((n) => {
      n.show = !n.show, t.nodesStatus[n.id] = n.show;
      const {
        getRenderer: e,
        clearSelect: a
      } = A().canvasApi.value;
      e().setCondition(n.id, n.show), a();
    }, {
      metaData: {
        id: `${$.id}.showNode`
      },
      ctx: () => ({
        props: E,
        emit: I,
        pageState: t,
        getMaterial: o,
        PLUGIN_NAME: r,
        panelFixed: D,
        useMultiSelect: s,
        registerHotkeyEvent: p,
        removeHotkeyEvent: b,
        selectedIds: l,
        panelState: k,
        filterSchema: d,
        state: u,
        subscribe: f,
        unsubscribe: m,
        eyeOpen: x,
        showNode: C,
        delNode: S,
        handleMouseEnterRow: i,
        disallowDrop: M,
        handleDrop: _,
        handleClickRow: N,
        getIconName: h,
        panelRef: c,
        eventFilter: v,
        PluginPanel: U,
        constants: G,
        useCanvas: A,
        useMaterial: B,
        useLayout: P,
        useMessage: z,
        useHistory: L,
        getMergeMeta: K,
        extend: F,
        DraggableTree: j,
        PAGE_STATUS: O
      })
    }), S = y((n) => {
      const {
        clearSelect: e
      } = A().canvasApi.value;
      A().operateNode({
        type: "delete",
        id: n.id
      }), e(), L().addHistory();
    }, {
      metaData: {
        id: `${$.id}.delNode`
      },
      ctx: () => ({
        props: E,
        emit: I,
        pageState: t,
        getMaterial: o,
        PLUGIN_NAME: r,
        panelFixed: D,
        useMultiSelect: s,
        registerHotkeyEvent: p,
        removeHotkeyEvent: b,
        selectedIds: l,
        panelState: k,
        filterSchema: d,
        state: u,
        subscribe: f,
        unsubscribe: m,
        eyeOpen: x,
        showNode: C,
        delNode: S,
        handleMouseEnterRow: i,
        disallowDrop: M,
        handleDrop: _,
        handleClickRow: N,
        getIconName: h,
        panelRef: c,
        eventFilter: v,
        PluginPanel: U,
        constants: G,
        useCanvas: A,
        useMaterial: B,
        useLayout: P,
        useMessage: z,
        useHistory: L,
        getMergeMeta: K,
        extend: F,
        DraggableTree: j,
        PAGE_STATUS: O
      })
    }), i = y((n) => {
      const {
        hoverNode: e
      } = A().canvasApi.value;
      e(n.id);
    }, {
      metaData: {
        id: `${$.id}.handleMouseEnterRow`
      },
      ctx: () => ({
        props: E,
        emit: I,
        pageState: t,
        getMaterial: o,
        PLUGIN_NAME: r,
        panelFixed: D,
        useMultiSelect: s,
        registerHotkeyEvent: p,
        removeHotkeyEvent: b,
        selectedIds: l,
        panelState: k,
        filterSchema: d,
        state: u,
        subscribe: f,
        unsubscribe: m,
        eyeOpen: x,
        showNode: C,
        delNode: S,
        handleMouseEnterRow: i,
        disallowDrop: M,
        handleDrop: _,
        handleClickRow: N,
        getIconName: h,
        panelRef: c,
        eventFilter: v,
        PluginPanel: U,
        constants: G,
        useCanvas: A,
        useMaterial: B,
        useLayout: P,
        useMessage: z,
        useHistory: L,
        getMergeMeta: K,
        extend: F,
        DraggableTree: j,
        PAGE_STATUS: O
      })
    }), M = y(({
      dragged: n,
      target: e,
      position: a
    }) => {
      if (n.id === "body")
        return !0;
      const g = a === "center" ? e : e.parent;
      if (g.id === "body")
        return !1;
      const {
        getConfigure: w,
        allowInsert: H
      } = A().canvasApi.value;
      return !H(w(g.rawData.componentName), n.rawData);
    }, {
      metaData: {
        id: `${$.id}.disallowDrop`
      },
      ctx: () => ({
        props: E,
        emit: I,
        pageState: t,
        getMaterial: o,
        PLUGIN_NAME: r,
        panelFixed: D,
        useMultiSelect: s,
        registerHotkeyEvent: p,
        removeHotkeyEvent: b,
        selectedIds: l,
        panelState: k,
        filterSchema: d,
        state: u,
        subscribe: f,
        unsubscribe: m,
        eyeOpen: x,
        showNode: C,
        delNode: S,
        handleMouseEnterRow: i,
        disallowDrop: M,
        handleDrop: _,
        handleClickRow: N,
        getIconName: h,
        panelRef: c,
        eventFilter: v,
        PluginPanel: U,
        constants: G,
        useCanvas: A,
        useMaterial: B,
        useLayout: P,
        useMessage: z,
        useHistory: L,
        getMergeMeta: K,
        extend: F,
        DraggableTree: j,
        PAGE_STATUS: O
      })
    }), _ = y(({
      dragged: n,
      target: e,
      position: a
    }) => {
      if (n.id === e.id || a === "center" && e.rawData.children.some((Y) => Y.id === n.id))
        return;
      if (a !== "center") {
        const Y = e.parent.rawData.children, V = Y.findIndex((X) => X.id === e.id), R = Y[a === "top" ? V - 1 : V + 1];
        if (n.id === (R == null ? void 0 : R.id))
          return;
      }
      const {
        insertNode: g,
        removeNode: w,
        selectNode: H
      } = A().canvasApi.value;
      w(n.id), g({
        data: n.rawData,
        node: e.rawData,
        parent: e.parent.rawData
      }, a === "center" ? "in" : a), Ce(() => {
        H(n.id, "clickTree");
      });
    }, {
      metaData: {
        id: `${$.id}.handleDrop`
      },
      ctx: () => ({
        props: E,
        emit: I,
        pageState: t,
        getMaterial: o,
        PLUGIN_NAME: r,
        panelFixed: D,
        useMultiSelect: s,
        registerHotkeyEvent: p,
        removeHotkeyEvent: b,
        selectedIds: l,
        panelState: k,
        filterSchema: d,
        state: u,
        subscribe: f,
        unsubscribe: m,
        eyeOpen: x,
        showNode: C,
        delNode: S,
        handleMouseEnterRow: i,
        disallowDrop: M,
        handleDrop: _,
        handleClickRow: N,
        getIconName: h,
        panelRef: c,
        eventFilter: v,
        PluginPanel: U,
        constants: G,
        useCanvas: A,
        useMaterial: B,
        useLayout: P,
        useMessage: z,
        useHistory: L,
        getMergeMeta: K,
        extend: F,
        DraggableTree: j,
        PAGE_STATUS: O
      })
    }), N = y((n, e) => {
      const a = n.ctrlKey || n.metaKey, {
        selectNode: g
      } = A().canvasApi.value;
      g(e.id, "clickTree", a);
    }, {
      metaData: {
        id: `${$.id}.handleClickRow`
      },
      ctx: () => ({
        props: E,
        emit: I,
        pageState: t,
        getMaterial: o,
        PLUGIN_NAME: r,
        panelFixed: D,
        useMultiSelect: s,
        registerHotkeyEvent: p,
        removeHotkeyEvent: b,
        selectedIds: l,
        panelState: k,
        filterSchema: d,
        state: u,
        subscribe: f,
        unsubscribe: m,
        eyeOpen: x,
        showNode: C,
        delNode: S,
        handleMouseEnterRow: i,
        disallowDrop: M,
        handleDrop: _,
        handleClickRow: N,
        getIconName: h,
        panelRef: c,
        eventFilter: v,
        PluginPanel: U,
        constants: G,
        useCanvas: A,
        useMaterial: B,
        useLayout: P,
        useMessage: z,
        useHistory: L,
        getMergeMeta: K,
        extend: F,
        DraggableTree: j,
        PAGE_STATUS: O
      })
    }), h = y((n) => (o(n.rawData.componentName).icon || "plugin-icon-page").toLowerCase(), {
      metaData: {
        id: `${$.id}.getIconName`
      },
      ctx: () => ({
        props: E,
        emit: I,
        pageState: t,
        getMaterial: o,
        PLUGIN_NAME: r,
        panelFixed: D,
        useMultiSelect: s,
        registerHotkeyEvent: p,
        removeHotkeyEvent: b,
        selectedIds: l,
        panelState: k,
        filterSchema: d,
        state: u,
        subscribe: f,
        unsubscribe: m,
        eyeOpen: x,
        showNode: C,
        delNode: S,
        handleMouseEnterRow: i,
        disallowDrop: M,
        handleDrop: _,
        handleClickRow: N,
        getIconName: h,
        panelRef: c,
        eventFilter: v,
        PluginPanel: U,
        constants: G,
        useCanvas: A,
        useMaterial: B,
        useLayout: P,
        useMessage: z,
        useHistory: L,
        getMergeMeta: K,
        extend: F,
        DraggableTree: j,
        PAGE_STATUS: O
      })
    }), c = re(null), v = y(() => c.value.$el.contains(document.activeElement), {
      metaData: {
        id: `${$.id}.eventFilter`
      },
      ctx: () => ({
        props: E,
        emit: I,
        pageState: t,
        getMaterial: o,
        PLUGIN_NAME: r,
        panelFixed: D,
        useMultiSelect: s,
        registerHotkeyEvent: p,
        removeHotkeyEvent: b,
        selectedIds: l,
        panelState: k,
        filterSchema: d,
        state: u,
        subscribe: f,
        unsubscribe: m,
        eyeOpen: x,
        showNode: C,
        delNode: S,
        handleMouseEnterRow: i,
        disallowDrop: M,
        handleDrop: _,
        handleClickRow: N,
        getIconName: h,
        panelRef: c,
        eventFilter: v,
        PluginPanel: U,
        constants: G,
        useCanvas: A,
        useMaterial: B,
        useLayout: P,
        useMessage: z,
        useHistory: L,
        getMergeMeta: K,
        extend: F,
        DraggableTree: j,
        PAGE_STATUS: O
      })
    });
    return Se(y(y(() => {
      c.value && p(document, {
        eventFilter: v
      });
    }, {
      metaData: {
        id: `${$.id}.onMounted[0]`
      },
      ctx: () => ({
        props: E,
        emit: I,
        pageState: t,
        getMaterial: o,
        PLUGIN_NAME: r,
        panelFixed: D,
        useMultiSelect: s,
        registerHotkeyEvent: p,
        removeHotkeyEvent: b,
        selectedIds: l,
        panelState: k,
        filterSchema: d,
        state: u,
        subscribe: f,
        unsubscribe: m,
        eyeOpen: x,
        showNode: C,
        delNode: S,
        handleMouseEnterRow: i,
        disallowDrop: M,
        handleDrop: _,
        handleClickRow: N,
        getIconName: h,
        panelRef: c,
        eventFilter: v,
        PluginPanel: U,
        constants: G,
        useCanvas: A,
        useMaterial: B,
        useLayout: P,
        useMessage: z,
        useHistory: L,
        getMergeMeta: K,
        extend: F,
        DraggableTree: j,
        PAGE_STATUS: O
      })
    }), {
      metaData: {
        id: `${$.id}.onMounted[0]`
      },
      ctx: () => ({
        props: E,
        emit: I,
        pageState: t,
        getMaterial: o,
        PLUGIN_NAME: r,
        panelFixed: D,
        useMultiSelect: s,
        registerHotkeyEvent: p,
        removeHotkeyEvent: b,
        selectedIds: l,
        panelState: k,
        filterSchema: d,
        state: u,
        subscribe: f,
        unsubscribe: m,
        eyeOpen: x,
        showNode: C,
        delNode: S,
        handleMouseEnterRow: i,
        disallowDrop: M,
        handleDrop: _,
        handleClickRow: N,
        getIconName: h,
        panelRef: c,
        eventFilter: v,
        _callEntry: y,
        _useCompile: W,
        _metaData: $,
        PluginPanel: U,
        constants: G,
        useCanvas: A,
        useMaterial: B,
        useLayout: P,
        useMessage: z,
        useHistory: L,
        getMergeMeta: K,
        extend: F,
        DraggableTree: j,
        PAGE_STATUS: O
      })
    })), _e(y(y(() => {
      c.value && b(document);
    }, {
      metaData: {
        id: `${$.id}.onBeforeUnmount[0]`
      },
      ctx: () => ({
        props: E,
        emit: I,
        pageState: t,
        getMaterial: o,
        PLUGIN_NAME: r,
        panelFixed: D,
        useMultiSelect: s,
        registerHotkeyEvent: p,
        removeHotkeyEvent: b,
        selectedIds: l,
        panelState: k,
        filterSchema: d,
        state: u,
        subscribe: f,
        unsubscribe: m,
        eyeOpen: x,
        showNode: C,
        delNode: S,
        handleMouseEnterRow: i,
        disallowDrop: M,
        handleDrop: _,
        handleClickRow: N,
        getIconName: h,
        panelRef: c,
        eventFilter: v,
        PluginPanel: U,
        constants: G,
        useCanvas: A,
        useMaterial: B,
        useLayout: P,
        useMessage: z,
        useHistory: L,
        getMergeMeta: K,
        extend: F,
        DraggableTree: j,
        PAGE_STATUS: O
      })
    }), {
      metaData: {
        id: `${$.id}.onBeforeUnmount[0]`
      },
      ctx: () => ({
        props: E,
        emit: I,
        pageState: t,
        getMaterial: o,
        PLUGIN_NAME: r,
        panelFixed: D,
        useMultiSelect: s,
        registerHotkeyEvent: p,
        removeHotkeyEvent: b,
        selectedIds: l,
        panelState: k,
        filterSchema: d,
        state: u,
        subscribe: f,
        unsubscribe: m,
        eyeOpen: x,
        showNode: C,
        delNode: S,
        handleMouseEnterRow: i,
        disallowDrop: M,
        handleDrop: _,
        handleClickRow: N,
        getIconName: h,
        panelRef: c,
        eventFilter: v,
        _callEntry: y,
        _useCompile: W,
        _metaData: $,
        PluginPanel: U,
        constants: G,
        useCanvas: A,
        useMaterial: B,
        useLayout: P,
        useMessage: z,
        useHistory: L,
        getMergeMeta: K,
        extend: F,
        DraggableTree: j,
        PAGE_STATUS: O
      })
    })), {
      panelFixed: D,
      selectedIds: l,
      panelRef: c,
      eyeOpen: x,
      delNode: S,
      showNode: C,
      state: u,
      PLUGIN_NAME: r,
      pageState: t,
      getIconName: h,
      handleClickRow: N,
      handleMouseEnterRow: i,
      disallowDrop: M,
      handleDrop: _
    };
  }
}, Ae = { class: "row-content" };
function Ie(E, I, t, o, r, D) {
  const s = Z("svg-icon"), p = Z("draggable-tree"), b = Z("plugin-panel");
  return q(), ie(b, {
    tabindex: "0",
    title: "大纲树",
    ref: "panelRef",
    class: "outlinebox plugin-tree",
    "fixed-name": o.PLUGIN_NAME.OutlineTree,
    fixedPanels: t.fixedPanels,
    onClose: I[0] || (I[0] = (l) => E.$emit("close"))
  }, {
    content: le(() => [
      ae(p, {
        "label-key": "componentName",
        data: o.state.pageSchema,
        draggable: !0,
        actives: o.selectedIds,
        "disallow-drop": o.disallowDrop,
        class: "outline-tree",
        onClick: o.handleClickRow,
        onMouseenter: o.handleMouseEnterRow,
        onDrop: o.handleDrop
      }, {
        content: le((l) => [
          te("div", Ae, [
            o.getIconName(l) ? (q(), ie(s, {
              key: 0,
              name: o.getIconName(l)
            }, null, 8, ["name"])) : ne("", !0),
            te("span", {
              class: ee(["row-label", { "node-isblock": l.rawData.componentType === "Block" }])
            }, Ne(l.label), 3),
            l.id !== "body" ? (q(), Q(se, { key: 1 }, [
              ae(s, {
                name: o.eyeOpen(l.id) ? "eye" : "eye-invisible",
                onMouseup: (k) => o.showNode(l.rawData)
              }, null, 8, ["name", "onMouseup"]),
              ae(s, {
                name: "delete",
                onMouseup: (k) => o.delNode(l.rawData)
              }, null, 8, ["onMouseup"])
            ], 64)) : ne("", !0)
          ])
        ]),
        _: 1
      }, 8, ["data", "actives", "disallow-drop", "onClick", "onMouseenter", "onDrop"])
    ]),
    _: 1
  }, 8, ["fixed-name", "fixedPanels"]);
}
const $e = /* @__PURE__ */ ce(Ee, [["render", Ie], ["__scopeId", "data-v-e2b34429"]]), Le = {
  ...$,
  entry: $e
};
export {
  Le as default
};
